require(AlgDesign) 
installed.packages(AlgDesign)

# Exemplo 1
# modelo qudaratico 
dat<-gen.factorial(levels=3,nVars=3,varNames=c("A","B","C"))
dat

desD<-optFederov(~quad(A,B,C),dat,nTrials=10,eval=TRUE)
desD
desA<-optFederov(~quad(.),dat,nTrials=14,eval=TRUE,crit="A")
desA
desI<-optFederov(~quad(.),dat,nTrials=14,eval=TRUE,crit="I")
desI


# EXemplo 2

dat<-gen.factorial(levels=3,nVars=4,varNames=c("A","B","C","D"))
dat

desD<-optFederov(~quad(A,B,C,D),dat,nTrials=20,eval=TRUE)
desD
desA<-optFederov(~quad(.),dat,nTrials=20,eval=TRUE,crit="A",nRepeats=10)
desA
desI<-optFederov(~quad(.),dat,nTrials=20,eval=TRUE,crit="I")
desI

# Experimento fracionario Plackett-Burman 

dat<-gen.factorial(levels=2,nVars=11,varNames=c("A","B","C","D","E","F","G","H","J","K","L"))
dat
desPB<-optFederov(~.,dat,12,nRepeats=20)
desPB



################################################################
### Controle Local
###############################################################
# Modelo quadratico 
# 

dat<-gen.factorial(3,3,varNames=c("A","B","C",))

desD<-optFederov(~quad(.),dat,nTrials=14,eval=TRUE) 
optBlock(~quad(.),desD$design,c(7,7))

desA<-optFederov(~quad(.),dat,nTrials=14,eval=TRUE,crit="A") 
optBlock(~quad(.),desA$design,c(7,7))


###################################################################
###### Eficiencias
################################################################
crit_D <- cbind(desD$D,desD$A,desD$I)
crit_D

crit_A <- cbind(desA$D,desA$A,desA$I)
crit_A

crit_I <- cbind(desI$D,desI$A,desI$I)
crit_I

print("linha: Delineamento  coluna:criterio")
crit <-rbind(crit_D,crit_A,crit_I)
crit
best <- matrix(apply(crit,2,max),nr=1)

eff <- matrix(apply(crit,1,function(x){100*(matrix(x,nr=1)/best)}),byrow=TRUE,nc=ncol(crit))

crit
eff
###########################################################